-- tolua: code class
-- Written by Waldemar Celes
-- TeCGraf/PUC-Rio
-- Jul 1999
-- $Id:$

-- This code is free software; you can redistribute it and/or modify it.
-- The software provided hereunder is on an "as is" basis, and
-- the author has no obligation to provide maintenance, support, updates,
-- enhancements, or modifications. 

$debug

-- Code class
-- Represents Lua code to be compiled and included
-- in the initialization function.
-- The following fields are stored:
--   text = text code
classCode = {
 text = '',
 _base = classFeature,
}
settag(classCode,tolua_tag)

-- register code
function classCode:register ()
 local o = tmpname()
 local n = tmpname()
 local f = openfile(n,'w')
 if not f then
  error('\n   cannot open temporary file to proccess embedded Lua code')
 end
 -- compile Lua code
 write(f,self.text)
 closefile(f)
 execute("luac -o "..o.." "..n)
 remove(n)
 
 -- convert to C
 local fp = openfile(o,'rb')
 if fp==nil then
  error('\n   cannot open temporary file to proccess embedded Lua code')
 end
 local s = read(fp,'.*')
 closefile(fp)
 remove(o)

 output('\n { /* begin embedded lua code */\n')
 output('  static unsigned char B[] = {\n   ')
 local t={n=0}
 output(gsub(s,'(.)',function (c) 
                      local e = '' 
                      %t.n=%t.n+1 if %t.n==20 then %t.n=0 e='\n   ' end 
                      return format('%3u,%s',strbyte(c),e) 
                     end))
 output('  };\n')
 output('  lua_dobuffer(B,sizeof(B),"tolua: embedded Lua code");')
 output(' } /* end of embedded lua code */\n\n')
end
 

-- Print method
function classCode:print (ident,close)
 print(ident.."Code{")
 print(ident.." text = [["..self.text.."]],")
 print(ident.."}"..close)
end


-- Internal constructor
function _Code (t)
 t._base = classCode
 settag(t,tolua_tag)
 append(t)
 return t
end

-- Constructor
-- Expects a string representing the code text
function Code (l)
 return _Code {
  text = l
 }
end


