-- tolua: abstract feature class
-- Written by Waldemar Celes
-- TeCGraf/PUC-Rio
-- Jul 1998
-- $Id: feature.lua,v 1.2 1999/07/28 22:21:09 celes Exp $

-- This code is free software; you can redistribute it and/or modify it.
-- The software provided hereunder is on an "as is" basis, and
-- the author has no obligation to provide maintenance, support, updates,
-- enhancements, or modifications. 

$debug


-- Feature class
classFeature = {
}

-- write support code
function classFeature:supcode ()
end

-- output tag
function classFeature:decltag ()
end

-- register feature
function classFeature:register ()
end

-- unregister feature
function classFeature:unregister ()
end

-- translate verbatim
function classFeature:preamble ()
end

-- check if feature is inside a class definition
function classFeature:inclass ()
 if self.parent and self.parent.type == 'class' then
  return self.parent.name
 else
  return nil
 end
end

-- check if feature is inside a module
function classFeature:inmodule ()
 if self.parent and self.parent.type == 'module' then
  return self.parent.name
 else
  return nil
 end
end

-- return C binding function name
-- the client specifies a prefix
function classFeature:cfuncname (n)
 if self.parent.parent then
  n = self.parent:cfuncname(n)
 end
 if self.lname then
  return n..'_'..self.lname
 else
  return n..'_'..self.name
 end  
end



